unit BarsU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OleCtrls, RTBARX;

type
  TForm1 = class(TForm)
    RTBARXCtrl1: TRTBARXCtrl;
    RTBARXCtrl2: TRTBARXCtrl;
    procedure FormCreate(Sender: TObject);
    procedure RTBARXCtrl1OnInternalTimer(Sender: TObject);
    procedure RTBARXCtrl2OnInternalTimer(Sender: TObject);
  private
  procedure BuildGraph1;
  procedure BuildGraph2;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
 uses CTWXDef;

{$R *.DFM}
VAR
  rData1, rData2: array[0..15] of double;

procedure TForm1.FormCreate(Sender: TObject);
begin
  BuildGraph1;  //build the first rt bargraph
  BuildGraph2;  //build the second rt bargraph
end;

Procedure TForm1.BuildGraph1;
var i: integer;
BEGIN
	RTBARXCtrl1.BarNumChannels := 8;

	//ALARM
	RTBARXCtrl1.BarAlarmMessageEnable := TRUE;
	RTBARXCtrl1.BarAlarmMarksEnable := TRUE;
	RTBARXCtrl1.BarHighAlarmValue  := 5.8;
	RTBARXCtrl1.BarLowAlarmValue  := 4.2;
	RTBARXCtrl1.BarHighAlarmString  := '*HI*';
	RTBARXCtrl1.BarLowAlarmString  := '*LO*';
	RTBARXCtrl1.BarNormalAlarmString  := 'ok';

	//DYN TEXT
	RTBARXCtrl1.BarDynTextEnable := TRUE;

	//SCALING AND CENTER POINT
	RTBARXCtrl1.BarScaleMin  := 4.0;
	RTBARXCtrl1.BarScaleMax  := 7.0;
	RTBARXCtrl1.BarScaleCenter  := 4.0;
	RTBARXCtrl1.BarTickSpace  := 1.0;
	RTBARXCtrl1.BarNumTicks  := 5;
        for i:= 0 to RTBARXCtrl1.BarNumChannels-1 do
           rData1[i] := 5; // Starting point for data simulation
	//AXIS LABEL PRECISION
	RTBARXCtrl1.BarLabelsPrecision  := 2;

	//COLORS
	RTBARXCtrl1.WindowBackgroundColor  := RGB_WHITE;

	//TITLE
	RTBARXCtrl1.TitleString [TITLE1] := 'Vertical Bar Graph';

	//INTERNAL TIMER
	RTBARXCtrl1.EnableInternalTimer := TRUE;

end;


Procedure TForm1.BuildGraph2;
var i: integer;
begin
	RTBARXCtrl2.BarNumChannels := 4;
	RTBARXCtrl2.BarType  := OR_HORZ; //draw a horizontal bar graph

	//COLORS
	RTBARXCtrl2.WindowBackgroundColor := RGB (128, 128, 0);
	RTBARXCtrl2.PlotBackgroundColor := RGB (128, 64, 0);

	//ALARMS
	RTBARXCtrl2.BarAlarmMarksEnable := TRUE;
	RTBARXCtrl2.BarAlarmMessageEnable := TRUE;
	RTBARXCtrl2.BarHighAlarmValue  := 5.9;
	RTBARXCtrl2.BarLowAlarmValue  := 4.1;
	RTBARXCtrl2.BarNumTicks  := 9;

	//TAG NAMES
	RTBARXCtrl2.BarChannelTagName[0] := 'One';
	RTBARXCtrl2.BarChannelTagName[1] := 'Two';
	RTBARXCtrl2.BarChannelTagName[2] := 'Three';
	RTBARXCtrl2.BarChannelTagName[3] := 'Four';
        for i:= 0 to RTBARXCtrl2.BarNumChannels-1 do
          rData2[i] := 5; // Starting point for data simulation

	// BAR COLORS
	RTBARXCtrl2.BarChannelColor[0]:= RGB (0, 0, 128);
	RTBARXCtrl2.BarChannelColor[1]:= RGB (255, 255, 0);
	RTBARXCtrl2.BarChannelColor[2]:= RGB (255, 255, 255);
	RTBARXCtrl2.BarChannelColor[3]:= RGB (0, 0, 0);

	//TITLES
	RTBARXCtrl2.TitleString[ TITLE1] := 'Horizontal Bar Graph';

	//INTERNAL TIMER
	RTBARXCtrl2.EnableInternalTimer := TRUE;

end;

procedure TForm1.RTBARXCtrl1OnInternalTimer(Sender: TObject);
var i: integer;
begin
   for i:= 0 to RTBARXCtrl1.BarNumChannels-1 do
     rData1[i] := rData1[i] + 0.5 * (0.5 - random);
   RTBARXCtrl1.UpdateDynData(rData1[0]);
end;

procedure TForm1.RTBARXCtrl2OnInternalTimer(Sender: TObject);
var i: integer;
begin
   for i:= 0 to RTBARXCtrl2.BarNumChannels-1 do
     rData2[i] := rData2[i] + 0.5 * (0.5 - random);
   RTBARXCtrl2.UpdateDynData(rData2[0]);
end;

end.
